/*
  sid (c) 1999-2004 by Dirk Jagdmann <doj@cubic.org>

  This file is part of sid.

  sid is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  sid is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
  License for more details.

  You should have received a copy of the GNU General Public License
  along with sid; if not, write to the Free Software Foundation, Inc.,
  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
  
  $Header: /code/cw/sid/raw.cc,v 1.4 2004/05/14 14:51:04 doj Exp $
*/

#include <memory>

#include "raw.hh"

extern char *errstr;

psid* loadRAW(FILE *f, byte *mem)
{
  if(f==0 || mem==0)
    return 0;

  if(fseek(f, 0, SEEK_SET) < 0)
    {
      errstr="loadRAW(): could not fseek to set";
      return 0;
    }

  // load
  std::auto_ptr<psid> ps(new psid);
  if(ps.get()==NULL)
    {
      errstr="loadRAW(): could not make a psid structure";
      return 0;
    }
  
  byte buf[2];
  if(fread(buf, 2, 1, f)!=1)
    {
      errstr="loadRAW(): error while reading a word";
      return 0;
    }
  ps->loadAddr=lohi(buf[0], buf[1]);
  ps->initAddr=ps->loadAddr;
  ps->playAddr=ps->loadAddr+3;

  fread(mem+ps->loadAddr, 1, 65536-ps->loadAddr, f);

  strcpy(ps->id, "raw");
  ps->version=0;
  ps->dataOffset=0;
  ps->songTotal=1;
  ps->songStart=0;
  ps->speed=0;
  ps->name[0]=0;
  ps->author[0]=0;
  ps->copyright[0]=0;
  ps->flags=0;
  ps->reserved=0;

  ps->songPlay=0;
  ps->MUSplayer=false;
  ps->PlaySIDSamples=false;
  ps->pal=true;
  ps->mos6581=false;
  ps->mos8580=false;

  return ps.release();
}
