/*
  sid (c) 1999-2004 by Dirk Jagdmann <doj@cubic.org>

  This file is part of sid.

  sid is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  sid is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
  License for more details.

  You should have received a copy of the GNU General Public License
  along with sid; if not, write to the Free Software Foundation, Inc.,
  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
  
  $Header: /code/cw/sid/raw.hh,v 1.4 2004/05/14 14:51:04 doj Exp $
*/

#ifndef RAW__HH
#define RAW__HH

#include <stdio.h>
#include "psid.h"

/**
   load a file into mem, which should conform to C64 .prg format, that
   is the first 2 bytes contain the load adress and the first two
   instructions are jumps to init and play routines.

   @param f stdio file
   @param mem pointer to 64K memory block
   @return pointer to psid structure containing valid initAddr, playAddr etc. If an error occured upon loading 0 is returned. The caller must delete the returned struct.
*/
psid* loadRAW(FILE *f, byte *mem);

#endif
